/*	
 *	main.c
 *
 *	sgwars - VvfEH[Y
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Sat Jul 13 06:20:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>

#include <piece.h>
#include <pclsprite.h>
#include <simple.h>
#include <smcvals.h> /* stdarg.hp */

extern unsigned char PAT[/*8*256*/];		/* XvCgp^[ */

/********************************************************
 ********************************************************
 ** Ȃ莎s̃\[XȂ̂ŁAǂ܂Ȃł **
 ********************************************************
 ********************************************************/

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* Q[x   */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ */

#define FIXBIT		6			/* Œ菬̏rbg    */
#define FIX(flt)	((short)((flt) * (1 << FIXBIT))) /* ->Œ菬 */
#define NUM(fix)	((short)(fix) >> FIXBIT) /* ->̂       */

#define WIDTH		DISP_Y			/* _ʕ */
#define HEIGHT		DISP_X			/* _ʍ */
#define N_OBJS		64			/* XvCgv[ */

#define MAX_MISSILES	3			/* ~TC */
#define MAX_UFOS	6			/* őUFO */
#define MAX_BEAMS	24			/* őr[ */
#define MAX_INSEKIS	24			/* ő覐ΐ */
#define MAX_PARTICLES	128			/* őp[eBN */

/* ʂ̃IuWFNg\ */
typedef struct _OBJECT {
	short stat;		/* (0:o/1`:ʂɒ`) */
	short x, y;		/* ʒu(Œ菬)                */
	short vx, vy;		/* Xs[h(Œ菬) (Cӎgp) */
	short anm;		/* Aj[VJE^        */
	short cnt1;		/* ėpJE^       (Cӎgp) */
} OBJECT;
/* stat̒l... */
/* ~TC */
#define MST_GND		1	/* n       */
#define MST_SKY		2	/*        */
/* UFO */
#define UST_NRM		1	/* ʏ */
/* r[ */
#define BST_NRM		1	/* ʏ */
/* 覐 */
#define IST_NRM		1	/* ʏ */
/* p[eBN */
#define PST_NRM		1	/* ʏ */

/* ~TCpp[^ */
#define MISSILE_X_MIN	FIX(8)			/* ړE */
#define MISSILE_X_MAX	FIX(WIDTH - 8)		/* EړE */
#define MISSILE_Y_MIN	FIX(-12)		/* ړE */
#define MISSILE_Y_MAX	FIX(HEIGHT - 17)	/* xW */
#define MISSILE_GND_VX	FIX(0.2)		/* nł̉ړx */
#define MISSILE_SKY_VX1	FIX(0.2)		/* 󒆂ł̒ᑬړx */
#define MISSILE_SKY_VY1	FIX(0.2)		/* 󒆂ł̒ᑬcړx */
#define MISSILE_SKY_VX2	FIX(0.5)		/* 󒆂ł̍ړx */
#define MISSILE_SKY_VY2	FIX(0.5)		/* 󒆂ł̍cړx */

/* UFOpp[^ */
#define UFO_X_MIN	FIX(-8)			/* ړE */
#define UFO_X_MAX	FIX(WIDTH + 8)		/* EړE */
#define UFO_Y1		FIX(8)			/* iYW  */
#define UFO_Y2		FIX(20)			/* iYW  */

/* r[pp[^ */
#define BEAM_Y_MAX	FIX(HEIGHT)		/* ړE */

/* 覐Ηpp[^ */
#define INSEKI_X_MIN	FIX(-4)			/* ړE */
#define INSEKI_X_MAX	FIX(WIDTH + 4)		/* EړE */
/* ㉺ʒuE覐΃tH[[V̂ƂŒ` */

/* Ehp[^ */
typedef struct _ROUNDINFO {
	short ufo_spd;			/* UFȌXs[h     */
	float ufo_accel;		/* UFO|т̉ */
	short beam_itv_min;		/* r[ˊԊu(ŏ)  */
	short beam_itv_max;		/* r[ˊԊu(ő)  */
	short beam_spd;			/* r[̃Xs[h      */
	short inseki_spd;		/* 覐΂̃Xs[h        */
} ROUNDINFO;
ROUNDINFO round_infos[] = {
	{ FIX(0.2), 1.25, SEC(5), SEC(10), FIX(1.0), FIX(0.4), },
	{ FIX(0.4), 1.25, SEC(5), SEC( 9), FIX(1.2), FIX(0.6), },
	{ FIX(0.6), 1.30, SEC(4), SEC( 8), FIX(1.4), FIX(0.8), },
	{ FIX(0.8), 1.30, SEC(4), SEC( 7), FIX(1.6), FIX(1.0), },
	{ FIX(1.0), 1.35, SEC(3), SEC( 6), FIX(1.8), FIX(1.2), },
	{ FIX(1.2), 1.35, SEC(3), SEC( 5), FIX(2.0), FIX(1.4), },
	{ FIX(1.4), 1.40, SEC(2), SEC( 4), FIX(2.2), FIX(1.6), },
	{ FIX(1.6), 1.40, SEC(2), SEC( 3), FIX(2.4), FIX(1.8), },
	{ FIX(1.8), 1.45, SEC(1), SEC( 2), FIX(2.6), FIX(2.0), },
	{ FIX(2.0), 1.45, SEC(1), SEC( 2), FIX(3.0), FIX(3.0), },
};
#define N_ROUND_INFOS (sizeof round_infos / sizeof *round_infos)

/* 覐΃tH[[V */
#define INSEKI_FRM_COLS		11
#define INSEKI_FRM_ROWS		10
#define INSEKI_Y_MIN	FIX(31)	/* ʒuEʒunE */
#define INSEKI_Y_MAX	(INSEKI_Y_MIN + FIX(8 * (INSEKI_FRM_ROWS - 1)))
char* inseki_frms[N_ROUND_INFOS] = {
/*0*/	    /*01234567890*/
	/*0*/"           "
	/*1*/"           "
	/*2*/"  o        "
	/*3*/"   o       "
	/*4*/"           "
	/*5*/"        o  "
	/*6*/"  o        "
	/*7*/"           "
	/*8*/"           "
	/*9*/"           ",
/*1*/	    /*01234567890*/
	/*0*/"           "
	/*1*/"        o  "
	/*2*/"           "
	/*3*/"    o      "
	/*4*/"           "
	/*5*/"  o        "
	/*6*/"           "
	/*7*/"        o  "
	/*8*/"  o        "
	/*9*/"           ",
/*2*/	    /*01234567890*/
	/*0*/"           "
	/*1*/"  o        "
	/*2*/"       o   "
	/*3*/"           "
	/*4*/"    o      "
	/*5*/"           "
	/*6*/"        o  "
	/*7*/"           "
	/*8*/"      o    "
	/*9*/"  o        ",
/*3*/	    /*01234567890*/
	/*0*/"           "
	/*1*/"   o       "
	/*2*/"        o  "
	/*3*/"           "
	/*4*/"    o  o   "
	/*5*/"           "
	/*6*/"         o "
	/*7*/"  o        "
	/*8*/"      o    "
	/*9*/"           ",
/*4*/	    /*01234567890*/
	/*0*/"           "
	/*1*/"     o     "
	/*2*/"           "
	/*3*/"   o  o    "
	/*4*/"           "
	/*5*/"        o  "
	/*6*/"   o       "
	/*7*/"           "
	/*8*/"     o     "
	/*9*/"  o      o ",
/*5*/	    /*01234567890*/
	/*0*/"           "
	/*1*/"    o      "
	/*2*/"           "
	/*3*/"  o     o  "
	/*4*/"   o       "
	/*5*/"       o   "
	/*6*/" o         "
	/*7*/"     o     "
	/*8*/"         o "
	/*9*/"   o       ",
/*6*/	    /*01234567890*/
	/*0*/"   o   o   "
	/*1*/"    o      "
	/*2*/"         o "
	/*3*/" o         "
	/*4*/"      o    "
	/*5*/"           "
	/*6*/"        o  "
	/*7*/"   o       "
	/*8*/"        o  "
	/*9*/" o         ",
/*7*/	    /*01234567890*/
	/*0*/"o    o o   "
	/*1*/"           "
	/*2*/"   o     o "
	/*3*/"        o  "
	/*4*/"           "
	/*5*/"    o  o   "
	/*6*/"           "
	/*7*/"      o    "
	/*8*/" o         "
	/*9*/"      o    ",
/*8*/	    /*01234567890*/
	/*0*/" o      o  "
	/*1*/"    o      "
	/*2*/"       o   "
	/*3*/"  o        "
	/*4*/"     o     "
	/*5*/"       o   "
	/*6*/"  o        "
	/*7*/"      o    "
	/*8*/" o       o "
	/*9*/"   o       ",
/*9*/	    /*01234567890*/
	/*0*/"        o  "
	/*1*/"    o o    "
	/*2*/"           "
	/*3*/"     o   o "
	/*4*/"  o        "
	/*5*/"       o   "
	/*6*/" o o       "
	/*7*/"           "
	/*8*/"     o   o "
	/*9*/" o      o  ",
};

/* LN^`(XvCgp^[̕) */
typedef struct _CHR {
	unsigned char x;	/* p^[ォLN^Sւ̃ItZbg */
	unsigned char y;
	unsigned char w;	/* p^[̉Ecѐ */
	unsigned char h;
	unsigned char* p;	/* p^[z(p[h][w]) */
} CHR;
CHR chr_missile	= { 3, 3, 1, 2, "\xe0\xf0" };
CHR chr_base	= { 7, 7, 2, 1, "\xf1\xf2" };
CHR chr_ufo[2]	= { { 7, 5, 2, 1, "\xe3\xe4" },
		    { 7, 5, 2, 1, "\xf3\xf4" } };
CHR chr_beam[2]	= { { 3, 7, 1, 1, "\xe5" },
		    { 3, 7, 1, 1, "\xf5" } };
CHR chr_inseki	= { 3, 3, 1, 1, "\xe1" };

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;			/* CWCup */

unsigned char bgbuff[DISP_X * DISP_Y / 8]; /* OtBbNobt@      */
				/* ڃt[obt@ƁA */
				/* ``̊ԂɍXVꍇ */
				/* _ł鋰ꂪ邩B             */
short sintbl[256];		/* 256sine[u(Œ菬)         */

unsigned timer;			/* O[o^C} */
int joy;			/* WCpbh */
int hiscore;			/* nCXRA */

int score;			/* ݂̃XRA */
int round;			/* Ehԍ */
ROUNDINFO* round_info;		/* Eh */
int n_missiles;			/* c~TC(݂̃~TC܂) */
OBJECT missile;			/* ~TC */
OBJECT ufos[MAX_UFOS];		/* UFO */
OBJECT beams[MAX_BEAMS];	/* r[ */
OBJECT insekis[MAX_INSEKIS];	/* 覐 */
OBJECT particles[MAX_PARTICLES];/* p[eBN */
int check_req;			/* ~TCo^C} */
int no_msg;			/* ~TCo҂̃bZ[W} */

unsigned char noise[sizeof(PCEWAVEINFO) + 16000 / 8];

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void schedule();
void patrot();
void spcls(int obj);
void bgcls();
void rprintf(int x, int y, const char* fmt, ...);
void bgpset(int x, int y);
void rspdisp(int obj, int x, int y, int pno);
int chrdisp(int obj, int x, int y, CHR* chr);
void bgdisp();
int rsphit(int x1, int y1, int pno1, int x2, int y2, int pno2);
int chrhit(int x1, int y1, CHR* chr1, int x2, int y2, CHR* chr2);
int demo();
void game();
/* ~TC */
void missile_gen();
void missile_work();
int missile_disp(int obj);
/* p[eBN */
void particle_gen(short x, short y, int type);
void particle_work();
void particle_disp();
/* UFO */
void ufo_gen();
void ufo_work();
int ufo_disp(int obj);
/* r[ */
void beam_gen(short x, short y);
void beam_work();
int beam_disp(int obj);
/* 覐 */
void inseki_gen();
void inseki_work();
int inseki_disp(int obj);

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	int i;
	float pi2;
	PCEWAVEINFO* pwi;

	/* cʂȂ̂ŁAXvCgp^[]B */
	patrot();

	/* \ݒB */
	dispmode(1,	/* XvCg\ */
		 1,	/* eLXg\ */
		 1,	/* OtBbN\ */
		 1,	/* OFeLXg`XvCg`OtBbNF */
		 0);	/* ʕ\Ȃ̂ŔwiF͖Ӗ */

	/* sine[u쐬B */
	pi2 = atan2(0, -1) * 2;
	for(i = 0; i < 256; i++) {
		sintbl[i] = FIX(sin(pi2 * i / 256));
	}

	/* mCY쐬B */
	for(i = 0; i < sizeof noise; i++) {
		noise[i] = rand() & 0x3f;
	}
	pwi = (PCEWAVEINFO*)(noise + 8);
	memset(pwi, 0, sizeof(PCEWAVEINFO));
	pwi->type = PW_TYPE_8BITPCM;
	pwi->len = sizeof noise - 8 - sizeof(PCEWAVEINFO);

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int prev_joy, trg;
	unsigned pause = 0;

	/* OtBbNʓ]B */
	bgdisp();
	bgcls(); /* ɏ */

REDO:
	/* [VSYNC҂B */
	if(prev == 0) prev = msec();
	do {
		cur = msec();
	} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
	prev = cur;

	/* pbhԎ擾B
	 * VvCuṕATRG_*ōKvB
	 */
	prev_joy = joy;
	joy = pad() & 0x00ff;
	joy = (joy & 0xf0) | (joy & PAD_LF ? PAD_UP : 0)
			   | (joy & PAD_RI ? PAD_DN : 0)
			   | (joy & PAD_UP ? PAD_RI : 0)
			   | (joy & PAD_DN ? PAD_LF : 0);
	trg = (joy ^ prev_joy) & joy;
	joy |= trg << 8;

	if(!pause) {
		if(joy & TRG_START) {
			sound(1);
			pause = 1;
		}
	} else {
		pause++;
		if(pause & 1) {
			rprintf(3, 7, "PAUSE");
		} else {
			rprintf(3, 7, "     ");
		}
		if(joy & TRG_START) {
			rprintf(3, 7, "     ");
			sound(1);
			pause = 0;
			joy &= ~TRG_START;
		}
	}
	if(pause) goto REDO;

	/* O[o^C}i߂B */
	timer++;
}

/****************************************************************************
 *	patrot
 ****************************************************************************/

/* wv[ȍ~̑SXvCg܂B */
void
spcls(int obj)
{
	while(obj < N_OBJS) {
		sppos(obj, -8, -8);
		obj++;
	}
}

/****************************************************************************
 *	bgcls
 ****************************************************************************/

/* OtBbNʂ܂B */
void
bgcls()
{
	memset(bgbuff, -1, sizeof bgbuff);
}

/****************************************************************************
 *	rprintf
 ****************************************************************************/

void
rprintf(int x, int y, const char* fmt, ...)
{
	va_list ap;
	int xcur, ycur;
	char str[256], *p, ch;

	/* \쐬B */
	va_start(ap, fmt);
	vsprintf(str, fmt, ap);
	va_end(ap);

	/* BGɕuB */
	p = str;
	xcur = x;
	ycur = y;
	while((ch = *p++) != '\0') {
		switch(ch) {
		case '\n': /* ŝݓʈ */
			xcur = x;
			ycur++;
			break;
		default:
			if(0 <= xcur && xcur <= BG_CX - 1 &&
			   0 <= ycur && ycur <= BG_CY - 1) {
				pclSpriteBGSetCharacter(0, ycur, DISP_Y / 8 - 1 - xcur, ch & 0xff);
			}
			xcur++;
			break;
		}
	}
}

/****************************************************************************
 *	bgpset
 ****************************************************************************/

/* OtBbNʂɓ_`܂B */
void
bgpset(int x, int y)
{
	if(x < 0 || WIDTH  - 1 < x) return;
	if(y < 0 || HEIGHT - 1 < y) return;
	bgbuff[(DISP_Y - 1 - x) * (DISP_X / 8) + y / 8] &= ~(1 << y % 8);
}

/****************************************************************************
 *	patrot
 ****************************************************************************/

/* Sp^[90x]܂B */
void
patrot()
{
	int i, j, x, y;
	unsigned char *p, src, dst[3][8];

	p = PAT;
	for(i = 0; i < 256; i++) {
		for(y = 0; y < 8; y++) {
			for(j = 0; j < 3; j++) {
				src = *p++;
				for(x = 0; x < 8; x++) {
					dst[j][7 - x] >>= 1;
					dst[j][7 - x] |= (src & 1) << 7;
					src >>= 1;
				}
			}
		}
		p -= 3 * 8;
		for(y = 0; y < 8; y++) {
			for(j = 0; j < 3; j++) {
				*p++ = dst[j][y];
			}
		}
	}
	bgset(PAT); /* mɔf */
}

/****************************************************************************
 *	rspdisp
 ****************************************************************************/

void
rspdisp(int obj, int x, int y, int pno)
{
	/* ʉ]̍Wϊsĕ\B */
	spdisp(obj++, y, DISP_Y - 8 - x, pno);
}

/****************************************************************************
 *	chrdisp
 ****************************************************************************/

int
chrdisp(int obj, int x, int y, CHR* chr)
{
	int i, j;
	unsigned char* p;

	/* SWւ̃ItZbgA_W炵܂B */
	x -= chr->x;
	y -= chr->y;

	/* XvCg\܂B */
	p = chr->p;
	for(i = 0; i < chr->h; i++) {
		for(j = 0; j < chr->w; j++) {
			rspdisp(obj++, x + j * 8, y + i * 8, *p++);
		}
	}

	return obj;
}

/****************************************************************************
 *	bgdisp
 ****************************************************************************/

void
bgdisp()
{
	int i, y;
	unsigned char *dst, *src;

	dst = pclSpriteBGGetFrameAdr(1);
	src = bgbuff;
	for(y = 0; y < DISP_Y; y++) { /* eCɂ... */
		for(i = 0; i < 3; i++) { /* bit1сAbit0сAmaskтɂ... */
			memcpy(dst, src, DISP_X / 8);
			dst += 256    / 8;
		}
		src += DISP_X / 8;
	}
}

/****************************************************************************
 *	rsphit
 ****************************************************************************/

/* XvCg1(x1,y1,pno1)ƃXvCg2(x2,y2,pno2)̓蔻B
 * Ȃ1AOȂ0Ԃ܂B
 * (̃p^[̃}XNɂAsNZPʂ̔ł)
 */
int
rsphit(int x1, int y1, int pno1, int x2, int y2, int pno2)
{
	int i, tmp;
	unsigned char *p1, *p2;
	unsigned short mask1, mask2;

	/* ʉ]̍WϊB */
	tmp = x1;
	      x1 = y1;
	           y1 = DISP_Y - 8 - tmp;
	tmp = x2;
	      x2 = y2;
	           y2 = DISP_Y - 8 - tmp;

	/* ܂ȔB */
	if(x1 + 8 - 1 < x2) return 0; /* XvCg1XvCg2荶 */
	if(y1 + 8 - 1 < y2) return 0; /* XvCg1XvCg2 */
	if(x2 + 8 - 1 < x1) return 0; /* XvCg1XvCg2E */
	if(y2 + 8 - 1 < y1) return 0; /* XvCg1XvCg2艺 */

	/* XvCgp^[AhXvZB */
	p1 = &PAT[(pno1 & 0xff/*Ô*/) * 8 * 3/*bit1,bit0,mask*/];
	p2 = &PAT[(pno2 & 0xff/*Ô*/) * 8 * 3/*bit1,bit0,mask*/];

	/* eCł̃sNZPʂ̓蔻B */
	if(y1 <= y2) {
		i = y2 - y1;
		p1 += i * 3;
	} else {
		i = y1 - y2;
		p2 += i * 3;
	}
	if(x1 <= x2) {
		x2 -= x1;
		      x1 = 0;
	} else {
		x1 -= x2;
		      x2 = 0;
	}
	do {
		/* ӁFXvCgf[^0:s/1: */
		mask1 = (p1[2/*mask*/] ^ 0xff) << x1;
		mask2 = (p2[2/*mask*/] ^ 0xff) << x2;
		if(mask1 & mask2) return 1;
		p1 += 3;
		p2 += 3;
	} while(++i < 8);

	return 0;
}

/****************************************************************************
 *	chrhit
 ****************************************************************************/

/* L1(x1,y1,chr1)ƃL2(x2,y2,chr2)̓蔻B
 * Ȃ1AOȂ0Ԃ܂B
 */
int
chrhit(int x1, int y1, CHR* chr1, int x2, int y2, CHR* chr2)
{
	int i1, j1, i2, j2;
	unsigned char *p1, pno1, *p2, pno2;

	/* SWւ̃ItZbgA_W炵܂B */
	x1 -= chr1->x;
	y1 -= chr1->y;
	x2 -= chr2->x;
	y2 -= chr2->y;

	/* ܂ȔB */
	if(x1 + chr1->w * 8 - 1 < x2) return 0; /* L1L2荶 */
	if(y1 + chr1->h * 8 - 1 < y2) return 0; /* L1L2 */
	if(x2 + chr2->w * 8 - 1 < x1) return 0; /* L1L2E */
	if(y2 + chr2->h * 8 - 1 < y1) return 0; /* L1L2艺 */

	/* L1̑SXvCgƃL2̑SXvCg̑蔻B */
	p1 = chr1->p;
	for(i1 = 0; i1 < chr1->h; i1++) {
		for(j1 = 0; j1 < chr1->w; j1++) {
			pno1 = *p1++;
			p2 = chr2->p;
			for(i2 = 0; i2 < chr2->h; i2++) {
				for(j2 = 0; j2 < chr2->w; j2++) {
					pno2 = *p2++;
					if(rsphit(x1 + j1 * 8, y1 + i1 * 8, pno1,
						  x2 + j2 * 8, y2 + i2 * 8, pno2)) return 1;
				}
			}
		}
	}
	return 0;
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result;

	/* ʃNAB */
	cls();
	spcls(0);

	/* ^Cg\B */
	/*             01234567890*/
	rprintf(0, 0, " 1P     HI ");
	rprintf(0, 1, "%05d %05d", score, hiscore);
	rprintf(0, 6, "  SIMPLE   ");
	rprintf(0, 8, "   G-WARS  ");

	for(;;) {
		schedule();

		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		if(timer % SEC(0.75) < SEC(0.5)) {
			rprintf(0,12, "  A :START ");
			rprintf(0,13, " SEL: EXIT ");
		} else {
			rprintf(0,12, "           ");
			rprintf(0,13, "           ");
		}
	}
	sound(0);

	/* ʃNAB */
	cls();
	spcls(0);

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	OBJECT* pm = &missile;
	OBJECT *pu, *pb, *pi;
	int obj;
	short spd;
	float accel;
	int i, j, k, x, y;
	int end_round;
	int point, point_x, point_y, point_cnt;
	char str[10];

	/* ʃNAB */
	cls();
	spcls(0);

	/* Q[Jn... */
	score = 0;
	round = 0;
	n_missiles = MAX_MISSILES;

	for(;;) {
		/* EhJn... */
		round_info = &round_infos[
			round < N_ROUND_INFOS ? round
					      : N_ROUND_INFOS - 1];

		/* ʃNAB */
		cls();
		spcls(0);

		/* bZ[W\B */
		/*             01234567890*/
		rprintf(0, 0, " 1P     HI ");
		rprintf(0, 1, "%05d %05d", score, hiscore);
		rprintf(0, 15, "%dLEFT", n_missiles);
		for(i = 0; i < SEC(2); i++) {
			schedule();
			if(i % SEC(0.5) < SEC(0.3)) {
				/*             01234567890*/
				rprintf(0, 7, "  ROUND%2d  ", (round + 1) % 100);
			} else {
				rprintf(0, 7, "  ROUND    ");
			}
		}
		no_msg = 1; /* Xe[WJñbZ[W} */

		/* ʃNAB */
		cls();
		spcls(0);

		/* IuWFNg\̃NAB */
		memset(&missile, 0, sizeof missile);
		memset(ufos, 0, sizeof ufos);
		memset(beams, 0, sizeof beams);
		memset(insekis, 0, sizeof insekis);
		memset(particles, 0, sizeof particles);

		/* IuWFNgoB */
		ufo_gen();	/* UFO */
		inseki_gen();	/* 覐 */
		check_req = 1;	/* ~TCo^C}Jn */

		point = 0;
		point_x = 0;
		point_y = 0;
		point_cnt = 0;

		for(;;) {
			schedule();

			if(check_req) {
				/* IB */
				end_round = 0;
				if(n_missiles == 0) end_round = 1; /* Q[I[o[ */
				for(i = 0, pu = ufos; i < MAX_UFOS; i++, pu++) {
					if(pu->stat) break;
				}
				if(i == MAX_UFOS) end_round = 1; /* EhNA */

				if(check_req >= SEC(3)) {
					cls();
					if(end_round) break;

					/* ~TCďoB */
					missile_gen();
					check_req = 0;	/* ~TCo^C}~ */

					memset(beams, 0, sizeof beams); /* r[ */

					/* UFÕXs[hČvZB */
#if 1
					accel = 1;
					for(i = 0, pu = ufos; i < MAX_UFOS; i++, pu++) {
						if(!pu->stat) accel *= round_info->ufo_accel;
					}
					spd = (short)(round_info->ufo_spd * accel);
#else /* Ȃł̓_Bpow()̂낤H */
					x = 0;
					for(i = 0, pu = ufos; i < MAX_UFOS; i++, pu++) {
						if(!pu->stat) x++;
					}
					accel = (float)pow(round_info->ufo_accel, x);
					accel = round_info->ufo_spd * accel;
					spd = (short)(accel);
#endif
					for(i = 0, pu = ufos; i < MAX_UFOS; i++, pu++) {
						if(!pu->stat) continue;
						if(pu->vx >= 0) {
							pu->vx = spd;
						} else {
							pu->vx = -spd;
						}
					}

					/* bZ[WB */
					no_msg = 0; /* 񂩂烁bZ[W\ */
				} else {
					if(no_msg) { /*Xe[WJn͕\Ȃ*/
						if(check_req < SEC(2)) check_req = SEC(2); /* Xe[WJn͂ƒZ߂ */
					} else if(check_req >= SEC(1)) { /* ҂̌㔼ɃbZ[W\ */
						if(end_round) {
							if(n_missiles == 0) {
								/* bZ[W\B */
								/*             01234567890*/
								rprintf(0, 0, " 1P     HI ");
								rprintf(0, 1, "%05d %05d", score, hiscore);
								rprintf(0, 7, " GAME OVER ", n_missiles % 10);
							}
						} else {
							/* bZ[W\B */
							if(check_req % SEC(0.5) < SEC(0.3)) {
								/*             01234567890*/
								rprintf(0, 0, " 1P     HI ");
								rprintf(0, 1, "%05d %05d", score, hiscore);
								rprintf(0, 7, "   %dLEFT   ", n_missiles % 10);
							} else {
								/*             01234567890*/
								rprintf(0, 0, " 1P     HI ");
								rprintf(0, 1, "      %05d", hiscore);
								rprintf(0, 7, "    LEFT   ");
							}
						}
					}
					check_req++;	/* ^C}JEgAbv */
				}
			}

			/* ړB */
			missile_work();
			ufo_work();
			beam_work();
			inseki_work();
			particle_work();

			/* ~TC<->UFO̓蔻B */
			if(pm->stat) {
				for(i = 0, pu = ufos; i < MAX_UFOS; i++, pu++) {
					if(!pu->stat) continue;
					if(!chrhit(NUM(pm->x), NUM(pm->y), &chr_missile,
						   NUM(pu->x), NUM(pu->y), &chr_ufo[NUM(pu->anm)])) continue;
					/* UFOjB */
					for(k = 0; k < 64; k++) particle_gen(pu->x, pu->y, 0);
					/*{{_vZ*/
					x = NUM(abs(pm->x - pu->x));
					if(x <= 0) {
						point = 300;
					} else if(x <= 2) {
						point = 150;
					} else if(x <= 4) {
						point = 100;
					} else {
						point = 50;
					}
					point_x = NUM(pu->x);
					point_y = NUM(pu->y);
					point_cnt = SEC(1);
					score += point;
					/*}}_vZ*/
					pu->stat = 0;	/* UFO */
					pm->stat = 0;	/* ~TC */
					check_req = 1;	/* ~TCo^C}Jn */
					no_msg = 1;	/* bZ[WȂ */
					sound(2);
					break;
				}
			}

			/* ~TC<->r[̓蔻B */
			if(pm->stat) {
				for(i = 0, pb = beams; i < MAX_BEAMS; i++, pb++) {
					if(!pb->stat) continue;
					if(!chrhit(NUM(pm->x), NUM(pm->y), &chr_missile,
						   NUM(pb->x), NUM(pb->y), &chr_beam[NUM(pb->anm)])) continue;
					/* ~TCjB */
					for(k = 0; k < 64; k++) particle_gen(pm->x, pm->y, 0);
					pb->stat = 0;	/* r[ */
					pm->stat = 0;	/* ~TC */
					check_req = 1;	/* ~TCo^C}Jn */
					n_missiles--;	/* ~TC炷 */
					sound(2);
					break;
				}
			}

			/* ~TC<->覐΂̓蔻B */
			if(pm->stat) {
				for(i = 0, pi = insekis; i < MAX_INSEKIS; i++, pi++) {
					if(!pi->stat) continue;
					if(!chrhit(NUM(pm->x), NUM(pm->y), &chr_missile,
						   NUM(pi->x), NUM(pi->y), &chr_inseki)) continue;
					/* ~TCjB */
					for(k = 0; k < 64; k++) particle_gen(pm->x, pm->y, 0);
					pm->stat = 0;	/* ~TC */
					check_req = 1;	/* ~TCo^C}Jn */
					n_missiles--;	/* ~TC炷 */
					sound(2);
					break;
				}
			}

			/* r[<->覐΂̓蔻B */
			for(i = 0, pb = beams; i < MAX_BEAMS; i++, pb++) {
				if(!pb->stat) continue;
				for(j = 0, pi = insekis; j < MAX_INSEKIS; j++, pi++) {
					if(!pi->stat) continue;
					if(!chrhit(NUM(pb->x), NUM(pb->y), &chr_beam[NUM(pb->anm)],
						   NUM(pi->x), NUM(pi->y), &chr_inseki)) continue;
					/* r[jB */
					for(k = 0; k < 16; k++) particle_gen(pb->x, pb->y, 0);
					pb->stat = 0;		/* r[ */
					break;
				}
			}

			/* \... */
			obj = 0;
			obj = missile_disp(obj);
			obj = ufo_disp(obj);
			obj = beam_disp(obj);
			obj = inseki_disp(obj);
			particle_disp();

			/* XvCg̎cv[܂B */
			spcls(obj);

			/* |Cg\B */
			if(point_cnt > 0) {
				i = sprintf(str, "%d", point % 10000);
				x = point_x - 8 * i / 2;
				y = point_y - 8 * 1 / 2;
				for(j = 0; j < i; j++) {
					rspdisp(N_OBJS - 1 - j, x, y, str[j]);
					x += 8;
				}
				point_cnt--;
			}
		}

		/* Q[I[o[H */
		if(n_missiles == 0) break;

		/* ̃EhցB */
		round++;
	}

	/* ʃNAB */
	cls();
	spcls(0);

	/* nCXRAXVH */
	if(score > hiscore) {
		hiscore = score;

		/* bZ[W\B */
		for(i = 0; i < SEC(2); i++) {
			schedule();
			if(i % SEC(0.5) < SEC(0.3)) {
				/*             01234567890*/
				rprintf(0, 7, " HI SCORE! ");
			} else {
				rprintf(0, 7, "           ");
			}
		}
	}
}

/****************************************************************************
 *	~TC
 ****************************************************************************/

void
missile_gen()
{
	OBJECT* pm = &missile;

	memset(pm, 0, sizeof(OBJECT));
	pm->stat = MST_GND;
	pm->x = (MISSILE_X_MIN + MISSILE_X_MAX) / 2;
	pm->y = MISSILE_Y_MAX;
}

void
missile_work()
{
	OBJECT* pm = &missile;
	int accel, i, n, x, y;

	switch(pm->stat) {
	case MST_GND:
		/* ړB */
		if(joy & PAD_LF) {
			pm->x -= MISSILE_GND_VX;
			if(pm->x < MISSILE_X_MIN) pm->x = MISSILE_X_MIN;
		}
		if(joy & PAD_RI) {
			pm->x += MISSILE_GND_VX;
			if(pm->x > MISSILE_X_MAX) pm->x = MISSILE_X_MAX;
		}
		/* ˁB */
		if(joy & (TRG_A | TRG_B) || ++pm->cnt1 >= SEC(10)) { /* 10bŋ */
			pm->stat = MST_SKY;
			pm->cnt1 = 0;
			return;
		}
		return;
	case MST_SKY:
		/* H */
		accel = joy & (PAD_A | PAD_B);
		/* ړB */
		if(joy & PAD_LF) {
			pm->x -= accel ? MISSILE_SKY_VX2 : MISSILE_SKY_VX1;
			if(pm->x < MISSILE_X_MIN) pm->x = MISSILE_X_MIN;
		}
		if(joy & PAD_RI) {
			pm->x += accel ? MISSILE_SKY_VX2 : MISSILE_SKY_VX1;
			if(pm->x > MISSILE_X_MAX) pm->x = MISSILE_X_MAX;
		}
		/* cړB */
		pm->y -= accel ? MISSILE_SKY_VY2 : MISSILE_SKY_VY1;
		if(pm->y < MISSILE_Y_MIN) { /* ɏďo */
			pm->stat = 0;	/* ~TC */
			check_req = 1;	/* ~TCo^C}Jn */
			no_msg = 1;	/* bZ[WȂ */
			return;
		}
		/* Ȃp[eBN𐶐B */
		if(accel) {
			for(i = 0; i < 2; i++) {
				n = FIX(rand() % 5 - 2);
				x = pm->x + n;
				y = pm->y + FIX(12) - abs(n);
				particle_gen(x, y, 1);
			}
			if(timer % SEC(0.1) == 0) ppdplay(noise);
		}
		return;
	}
}

int
missile_disp(int obj)
{
	OBJECT* pm = &missile;
	int x, y;

	switch(pm->stat) {
	case MST_GND:
		x = NUM(pm->x);
		y = NUM(pm->y);
		obj = chrdisp(obj, x, y, &chr_missile); /* ~TC */
		y += 16;
		obj = chrdisp(obj, x, y, &chr_base); /* C */
		return obj;
	case MST_SKY:
		x = NUM(pm->x);
		y = NUM(pm->y);
		obj = chrdisp(obj, x, y, &chr_missile); /* ~TC */
		return obj;
	}

	return obj;
}

/****************************************************************************
 *	p[eBN
 ****************************************************************************/

void
particle_gen(short x, short y, int type)
{
	OBJECT *pp, *pp_old;
	int i, d, s;

	/* 󂫃Gg܂͈ԋGgT܂B */
	pp_old = NULL;
	for(i = 0, pp = particles; i < MAX_PARTICLES; i++, pp++) {
		if(!pp->stat){ /* 󂫃Gg */
			pp_old = pp;
			break;
		}
		if(pp_old == NULL || pp->cnt1 < pp_old->cnt1) {
			pp_old = pp; /* ܂͎Ȃ̃Gg */
		}
	}
	pp = pp_old;

	/* p[eBNB */
	pp->stat = PST_NRM;
	pp->x = x;
	pp->y = y;
	switch(type) {
	case 0: /* ˏ^Cv */
		d = rand() % 256;
		s = rand() % FIX(1) + FIX(1);
		pp->vx = sintbl[(d + 64) % 256] * s >> FIXBIT;
		pp->vy = sintbl[d             ] * s >> FIXBIT;
		pp->cnt1 = SEC(0.75);
		break;
	case 1: /* ^Cv */
		pp->vx = 0;
		pp->vy = rand() % FIX(0.5) + FIX(0.5);
		pp->cnt1 = SEC(0.33);
		break;
	case 2: /* ^Cv */
		pp->vx = -(rand() % FIX(0.5) + FIX(0.5));
		pp->vy = 0;
		pp->cnt1 = SEC(0.33);
		break;
	case 3: /* E^Cv */
		pp->vx = rand() % FIX(0.5) + FIX(0.5);
		pp->vy = 0;
		pp->cnt1 = SEC(0.33);
		break;
	}
}

void
particle_work()
{
	OBJECT* pp;
	int i;

	for(i = 0, pp = particles; i < MAX_PARTICLES; i++, pp++) {
		if(!pp->stat) continue;

		/* ^CAEgÃGgɂăXLbvB */
		if(--pp->cnt1 <= 0) {
			pp->stat = 0;
			continue;
		}

		/* ړB */
		pp->x += pp->vx;
		pp->y += pp->vy;
	}
}

void
particle_disp()
{
	OBJECT* pp;
	int i, x, y;

	for(i = 0, pp = particles; i < MAX_PARTICLES; i++, pp++) {
		if(!pp->stat) continue;

		/* p[eBN̈ʒuɓ_`܂B */
		x = NUM(pp->x);
		y = NUM(pp->y);
		bgpset(x, y);
	}
}

/****************************************************************************
 *	UFO
 ****************************************************************************/

void
ufo_gen()
{
	OBJECT* pu;
	int i, x, y;

	pu = ufos;

	/* i */
	y = UFO_Y1;
	x = UFO_X_MIN;
	for(i = 0; i < MAX_UFOS / 2; i++, pu++) {
		pu->stat = UST_NRM;
		pu->x = x;
		pu->y = y;
		pu->vx = round_info->ufo_spd;
		pu->anm = 0;
		pu->cnt1 = round_info->beam_itv_min + rand() % (round_info->beam_itv_max - round_info->beam_itv_min);
		x += (UFO_X_MIN - UFO_X_MAX) / (MAX_UFOS / 2);
	}

	/* i */
	y = UFO_Y2;
	x = UFO_X_MIN + (UFO_X_MIN - UFO_X_MAX) / (MAX_UFOS / 2) / 2;
	for(i = 0; i < MAX_UFOS / 2; i++, pu++) {
		pu->stat = UST_NRM;
		pu->x = x;
		pu->y = y;
		pu->vx = -round_info->ufo_spd;
		pu->anm = 0;
		pu->cnt1 = round_info->beam_itv_min + rand() % (round_info->beam_itv_max - round_info->beam_itv_min);
		x += (UFO_X_MIN - UFO_X_MAX) / (MAX_UFOS / 2);
	}
}

void
ufo_work()
{
	OBJECT* pu;
	int i;

	for(i = 0, pu = ufos; i < MAX_UFOS; i++, pu++) {
		switch(pu->stat) {
		case UST_NRM:
			/* EړB */
			pu->x += pu->vx;
			while(pu->x <  UFO_X_MIN) pu->x += (UFO_X_MAX - UFO_X_MIN);
			while(pu->x >= UFO_X_MAX) pu->x -= (UFO_X_MAX - UFO_X_MIN);

			/* r[ˁH */
			if(--pu->cnt1 <= 0) {
				if(!check_req) { /* ~TCo҂̓r[Ȃ */
					beam_gen(pu->x, pu->y + FIX(8));
				}
				pu->cnt1 = round_info->beam_itv_min + rand() % (round_info->beam_itv_max - round_info->beam_itv_min);
			}

			/* AjVJE^i߂B */
			pu->anm += abs(pu->vx);
			pu->anm %= FIX(2);
		}
	}
}

int
ufo_disp(int obj)
{
	OBJECT* pu;
	int i, x, y;

	for(i = 0, pu = ufos; i < MAX_UFOS; i++, pu++) {
		switch(pu->stat) {
		case UST_NRM:
			x = NUM(pu->x);
			y = NUM(pu->y);
			obj = chrdisp(obj, x, y, &chr_ufo[NUM(pu->anm)]);
			break;
		}
	}

	return obj;
}

/****************************************************************************
 *	r[
 ****************************************************************************/

void
beam_gen(short x, short y)
{
	OBJECT* pb;
	int i;

	/* 󂫃GgT܂B */
	for(i = 0, pb = beams; i < MAX_BEAMS; i++, pb++) {
		if(!pb->stat) break;
	}
	if(i == MAX_BEAMS) return; /* 󂫃GgȂ */

	/* r[B */
	pb->stat = BST_NRM;
	pb->x = x;
	pb->y = y;
	pb->vy = round_info->beam_spd;
	pb->anm = 0;
}

void
beam_work()
{
	OBJECT* pb;
	int i;

	for(i = 0, pb = beams; i < MAX_BEAMS; i++, pb++) {
		switch(pb->stat) {
		case BST_NRM:
			/* B */
			pb->y += pb->vy;
			/* nʂɓB */
			if(pb->y >= BEAM_Y_MAX) {
				for(i = 0; i < 16; i++) particle_gen(pb->x, pb->y, 0);
				pb->stat = 0;
				continue;
			}
			/* AjVJE^i߂B */
			pb->anm += FIX(0.5);
			pb->anm %= FIX(2);
			break;
		}
	}
}

int
beam_disp(int obj)
{
	OBJECT* pb;
	int i, x, y;

	for(i = 0, pb = beams; i < MAX_BEAMS; i++, pb++) {
		switch(pb->stat) {
		case BST_NRM:
			x = NUM(pb->x);
			y = NUM(pb->y);
			obj = chrdisp(obj, x, y, &chr_beam[NUM(pb->anm)]);
			break;
		}
	}

	return obj;
}

/****************************************************************************
 *	覐
 ****************************************************************************/

void
inseki_gen()
{
	OBJECT* pi;
	int i, x, y;
	char* frm;

	pi = insekis;
	i = 0;

	frm = inseki_frms[round < N_ROUND_INFOS ? round
						: N_ROUND_INFOS - 1];
	for(y = 0; y < INSEKI_FRM_ROWS; y++) {
		for(x = 0; x < INSEKI_FRM_COLS; x++) {
			if(*frm++ == ' ') continue;

			pi->stat = IST_NRM;
			pi->x = FIX(x * 8);
			pi->y = FIX(y * 8) + INSEKI_Y_MIN;
			pi->vx = y & 1 ? -round_info->inseki_spd
				       :  round_info->inseki_spd;

			pi++;
			i++;
			if(i == MAX_INSEKIS) return;
		}
	}
}

void
inseki_work()
{
	OBJECT* pi;
	int i, n, x, y;

	for(i = 0, pi = insekis; i < MAX_INSEKIS; i++, pi++) {
		switch(pi->stat) {
		case IST_NRM:
			/* EړB */
			pi->x += pi->vx;
			if(pi->vx >= 0) {
				if(pi->x > INSEKI_X_MAX) { /* ړ */
					pi->x = INSEKI_X_MAX;
					pi->y += FIX(8);
					pi->vx = -pi->vx;
				}
			} else {
				if(pi->x < INSEKI_X_MIN) { /* ړ */
					pi->x = INSEKI_X_MIN;
					pi->y += FIX(8);
					pi->vx = -pi->vx;
				}
			}
			/* [vB */
			if(pi->y > INSEKI_Y_MAX) {
				pi->x = INSEKI_X_MIN;
				pi->y = INSEKI_Y_MIN;
				pi->vx = abs(pi->vx); /* ŏi͉Eړ */
			}
			/* p[eBNB */
			n = FIX(rand() % 7 - 3);
			y = pi->y + n + 1;
			if(pi->vx >= 0) {
				x = pi->x - FIX(4) + abs(n);
				particle_gen(x, y, 2);
			} else {
				x = pi->x + FIX(4) - abs(n);
				particle_gen(x, y, 3);
			}
			break;
		}
	}
}

int
inseki_disp(int obj)
{
	OBJECT* pi;
	int i, x, y;

	for(i = 0, pi = insekis; i < MAX_INSEKIS; i++, pi++) {
		switch(pi->stat) {
		case IST_NRM:
			x = NUM(pi->x);
			y = NUM(pi->y);
			obj = chrdisp(obj, x, y, &chr_inseki);
			break;
		}
	}

	return obj;
}
